///////////////////////////////////////////////////////////////////////////////
/*
                                geolocate.js

COPYRIGHT
---------
Copyright (C)  Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under the
conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or any later version.
http://www.gnu.org/licenses/gpl.txt


VERSION
-------
10-AUG-2017  MGD  initial
*/
///////////////////////////////////////////////////////////////////////////////

var geoLocateFreeService = 'freegeoip.net';
var geoLocateIpApiService = 'ip-api.com';

var geoLocateHost = [];
var geoLocateData = [];
var geoLocateFail = 0;
var geoLocateService = null;

function geoLocateFunction(idx,host)
{
   if (!geoLocateService) geoLocateSetService();
   if (geoLocateFunction) geoLocateFunction(idx,host);
}

function geoLocateSetService(idx,host)
{
   // can be "!" to disable, "*" for default, or host name for service
   geoLocateService = alam_StaticData.geoLocate;
   if (geoLocateService == '!')
      geoLocateFunction = null;
   else
   if (geoLocateService == '*') {
      geoLocateService = geoLocateFreeService;
      geoLocateFunction = geoLocateFree;
   }
   else
   if (geoLocateService == '+') {
      acmeLoadFile('geolocateplus.js');
      geoLocateFunction = null;
      setTimeout('geoLocateFunction = geoLocatePlus;',250);
   }
   else
   if (geoLocateService == geoLocateFreeService)
      geoLocateFunction = geoLocateFree;
   else
   if (geoLocateService == geoLocateIpApiService)
      geoLocateFunction = geoLocateIpApi;
   else
      geoLocateFunction = geoLocateFree;
}

///////////////////////////////////////////////////////////////////////////////

function geoLocate(host)
{
   var gld, idx, jsn, url, xhr;
   if (!geoLocateFunction || geoLocateFail > 30) {
      $byId('reqClientGeo').innerHTML = '';
      return;
   }
   for (idx = 0; idx < geoLocateHost.length; idx++) {
      if (geoLocateHost[idx] == host) {
         if (geoLocateData[idx] == '{!}') break;
         $byId('reqClientGeo').innerHTML = geoLocateData[idx];
         return;
      }
   }
   $byId('reqClientGeo').innerHTML = '';
   geoLocateHost[idx] = host;
   geoLocateData[idx] = '{!}';
   geoLocateFunction(idx,host);
}

///////////////////////////////////////////////////////////////////////////////

function geoLocateFree(idx,host)
{
   url = 'https://' + geoLocateService + '/json/' + host;
   xhr = new XMLHttpRequest();
   xhr.open('GET', url, true);

   xhr.onreadystatechange = function()
   {
      if (this.readyState == 4)
      {
         if (this.status == 200) {
            jsn = JSON.parse(this.responseText);
            if (jsn['country_name'] == '')
               gld = ' {?';
            else
               gld = ' {' + jsn['country_name'];
            if (jsn['region_name'] != '' &&
                jsn['region_name'] != jsn['country_name'])
               gld += ', ' + jsn['region_name'];
            if (jsn['city'] != '' && jsn['city'] != jsn['region_name'])
               gld += ', ' + jsn['city'];
            gld += '}';
         }
         else
         if (this.status == 403) {
            gld = ' {exceeded hourly limit}';
         }
         else
         if (this.status == 404) {
            gld = ' {failed: ' + host + '}';
         }
         else
         if (this.status) {
            gld = ' {HTTP ' + this.status + ' error}';
         }
         else
            gld = '';

         geoLocatedAt(idx,gld,(this.status == 0));
      }
   };

   xhr.send(); 
}

///////////////////////////////////////////////////////////////////////////////

function geoLocateIpApi(idx,host)
{
   url = 'http://' + geoLocateService + '/json/' + host;
   xhr = new XMLHttpRequest();
   xhr.open('GET', url, true);

   xhr.onreadystatechange = function()
   {
      if (this.readyState == 4)
      {
         if (this.status == 200) {
            jsn = JSON.parse(this.responseText);
            if (jsn['status'] == 'success')
            {
               if (jsn['country'] == '')
                  gld = ' {?';
               else
                  gld = ' {' + jsn['country'];
               if (jsn['regionName'] != '' &&
                   jsn['regionName'] != jsn['country'])
                  gld += ', ' + jsn['regionName'];
               if (jsn['city'] != '' && jsn['city'] != jsn['regionName'])
                  gld += ', ' + jsn['city'];
               gld += '}';
            }
            else {
               gld = ' {failed: ' + jsn['message'] + ': ' + jsn['query'] + '}';
            }
         }
         else
         if (this.status) {
            gld = ' {HTTP ' + this.status + ' error}';
         }
         else
            gld = '';

         geoLocatedAt(idx,gld,(this.status == 0));
      }
   };

   xhr.send(); 
}

///////////////////////////////////////////////////////////////////////////////

function geoLocatedAt (idx,data,failed)
{
   $byId('reqClientGeo').innerHTML = (geoLocateData[idx] = data);

   if (failed)
      geoLocateFail++;
   else
      geoLocateFail = 0;
}

///////////////////////////////////////////////////////////////////////////////

